︠3018a2d7-1216-45b1-9dfe-2ca814fce87as︠
# question 1 
# create a relation as a set of ordered pairs.
r1 = {(1,2),(2,3),(3,4),(1,3)}
r2 = {(a,b) for a in range(1,4) for b in range (1,4) if a<=b}

print(r1)
print(r2)
︡31e419e1-0f91-46af-8b50-76707ec8c2d1︡{"stdout":"{(2, 3), (1, 2), (1, 3), (3, 4)}\n"}︡{"stdout":"{(1, 2), (1, 1), (2, 3), (3, 3), (2, 2), (1, 3)}\n"}︡{"done":true}
︠cb463430-8257-435c-a70d-e5e72e4798c7s︠

# Q2
def is_reflexive(r,elements):
    return all((a,a) in r for a in elements)

# to check if it is antisymetric
def is_antisymmetric(r):
    return all (a==b or (b,a) not in r for (a,b) in r)
# to check if it is transitive
def is_transitive(r):

    return all((a, c) in r for (a, b) in r for (_, c) in r if b == _)
# to check if it is reflexive
def is_partial_order(r, elements):
    
    return is_reflexive(r, elements) and is_antisymmetric(r) and is_transitive(r)

r = {(1, 2), (2, 3), (1, 3)}

# Set of elements
elements = {1, 2, 3}

# Check properties
print("Is the relation reflexive?", is_reflexive(r, elements))

print("Is the relation antisymmetric?", is_antisymmetric(r))

print("Is the relation transitive?", is_transitive(r))
print("Is the relation a partial order?", is_partial_order(r, elements))
︡b5097e20-42ef-46a7-a592-9db5a449be0a︡{"stdout":"Is the relation reflexive? False\n"}︡{"stdout":"Is the relation antisymmetric? True\n"}︡{"stdout":"Is the relation transitive? True\n"}︡{"stdout":"Is the relation a partial order? False\n"}︡{"done":true}
︠493c0c94-a336-4ab7-9d4b-6f0672d8d425s︠

#Q3
p=Poset((divisors(24), attrcall("divides")), linear_extension=True)
p.cover_relations()

p.maximal_elements()
p.minimal_elements()
p.show()
︡f3baa4bd-6b57-40ae-9205-05310ac0af35︡{"stdout":"[[1, 2], [1, 3], [2, 4], [2, 6], [3, 6], [4, 8], [4, 12], [6, 12], [8, 24], [12, 24]]\n"}︡{"stdout":"[24]\n"}︡{"stdout":"[1]\n"}︡{"file":{"filename":"/tmp/tmpkvi2vzyb/tmp_z1swz81_.svg","show":true,"text":null,"uuid":"7abf1a6c-a54f-4892-8274-676bfefe1189"},"once":false}︡{"done":true}
︠c33adee9-15f0-4161-9b2c-0ca3fbf65ee6s︠

 #Q4
P1=Poset((divisors(12),attrcall("divides")),linear_extension=True)
P1.show()
S1=Poset((divisors(6),attrcall("divides")),linear_extension=True)
S1.show()
#upperBound   &   LowerBound
def is_upper_bound(element,S):
    return all(s <= element for s in S)
def is_lower_bound(element,S):
   return all(element <= s for s in S)
is_lower_bound(1,P1)
is_upper_bound(12,P1)
upper_bounds = [u for u in P1 if is_upper_bound(u,S1)]
lower_bounds = [l for l in P1 if is_lower_bound(l,S1)]
lower_bounds
upper_bounds
LUB = min(upper_bounds) if upper_bounds else None
GLB = max(lower_bounds) if lower_bounds else None
LUB 
GLB
︡3cbe4f2e-cf66-4be4-b7f8-6f459fc984be︡{"file":{"filename":"/tmp/tmpkvi2vzyb/tmp_9u8z1fxy.svg","show":true,"text":null,"uuid":"f9326f15-ac11-4fae-8fde-4b467a824dd9"},"once":false}︡{"file":{"filename":"/tmp/tmpkvi2vzyb/tmp_h3l4swxx.svg","show":true,"text":null,"uuid":"27b04117-850d-4686-b2b9-b86e52cd1b4b"},"once":false}︡{"stdout":"True\n"}︡{"stdout":"True\n"}︡{"stdout":"[1]\n"}︡{"stdout":"[6, 12]\n"}︡{"stdout":"6\n"}︡{"stdout":"1\n"}︡{"done":true}
︠bf4e7203-b0d4-451f-881e-fa2f020a6d70s︠

#Q5
A1=Poset((divisors(24),attrcall("divides")),linear_extension=True)
A1.show()
A1.is_lattice()
︡e0f52e4c-37c2-4a6e-8eb0-a1026ecbb01c︡{"file":{"filename":"/tmp/tmpkvi2vzyb/tmp_q064ggz3.svg","show":true,"text":null,"uuid":"30ad9354-4c7f-4d6b-a5cc-24f85db98773"},"once":false}︡{"stdout":"True\n"}︡{"done":true}
︠f15ddc20-9c88-480e-a39d-d3c66b7a3018s︠

 #Q6
A=Poset({0:[1,2],2:[3,4]})
A.show()
A.is_lattice()
︡d2212ceb-ff95-4cde-9dbd-c582c55c1d89︡{"file":{"filename":"/tmp/tmpkvi2vzyb/tmp_ha1ehdox.svg","show":true,"text":null,"uuid":"35505810-2cf1-4855-8943-8eb9c8e34850"},"once":false}︡{"stdout":"False\n"}︡{"done":true}
︠11c4daa3-17c4-402b-b24e-ef7410cfd480s︠

︡3f9eec82-a638-4211-8916-4ddc0820de0f︡{"done":true}









